//Almost everything that makes Jet Metal Sonic tick is in here
freeslot(
	"SPR_JMSC","SPR_JMSA",
	"SPR2_CHRG","SPR2_CJMP","SPR2_JMSB",
	"S_PLAY_CHRGJMP","S_PLAY_CHRGTHK","S_PLAY_POSTWBNC","S_PLAY_POSTHOME","S_PLAY_DASHREADY","S_PLAY_JMSDEAD",
	"S_LAUNCHEFF","S_CHRGSPARKLE","S_JETMETBSTERA","S_JETMETBSTERB",
	"MT_JETMETBSTERA","MT_JETMETBSTERB",
	"SKINCOLOR_JETMETAL"
	)
for i = 1, 7 freeslot("S_CHRGEFF"..i) end
for i = 1, 5 freeslot("SKINCOLOR_SUPERJETMETAL"..i) end

states[S_PLAY_CHRGJMP] = {SPR_PLAY, SPR2_CJMP|FF_ANIMATE, -1, nil, 7, 1, S_PLAY_CHRGJMP}
states[S_PLAY_CHRGTHK] = {SPR_PLAY, SPR2_DASH|A, 14, nil, 0, 0, S_PLAY_ROLL}
states[S_PLAY_POSTWBNC] = {SPR_PLAY, SPR2_SPNG|A, 14, nil, 0, 0, S_PLAY_ROLL}
states[S_PLAY_POSTHOME] = {SPR_PLAY, SPR2_SPNG|A, 14, nil, 0, 0, S_PLAY_ROLL}
states[S_PLAY_DASHREADY] = {SPR_PLAY, SPR2_CHRG|A, -1, nil, 7, 1, S_PLAY_DASHREADY}
states[S_PLAY_JMSDEAD] = {SPR_PLAY, SPR2_CNT1|A, 1, nil, 0, 0, S_PLAY_JMSDEAD}

states[S_LAUNCHEFF] = {SPR_JMSC, FF_TRANS50|FF_FULLBRIGHT|FF_ANIMATE, 7, nil, 6, 1, S_NULL}
states[S_CHRGSPARKLE] = {SPR_NSPK, FF_TRANS20|FF_FULLBRIGHT|FF_ANIMATE, 8, nil, 3, 1, S_NULL}
states[S_CHRGEFF1] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|G, 1, nil, 0, 0, S_CHRGEFF2}
states[S_CHRGEFF2] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|F, 1, nil, 0, 0, S_CHRGEFF3}
states[S_CHRGEFF3] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|E, 1, nil, 0, 0, S_CHRGEFF4}
states[S_CHRGEFF4] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|D, 1, nil, 0, 0, S_CHRGEFF5}
states[S_CHRGEFF5] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|C, 1, nil, 0, 0, S_CHRGEFF6}
states[S_CHRGEFF6] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|B, 1, nil, 0, 0, S_CHRGEFF7}
states[S_CHRGEFF7] = {SPR_JMSC, FF_TRANS50|FF_PAPERSPRITE|FF_FULLBRIGHT|A, 1, nil, 0, 0, S_NULL}
states[S_JETMETBSTERA] = {SPR_NULL, A, -1, nil, 0, 0, S_NULL}
states[S_JETMETBSTERB] = {SPR_NULL, B, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_JETMETBSTERA] = {spawnstate = S_JETMETBSTERA, radius = 20*FRACUNIT, height = 16*FRACUNIT, flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING}
mobjinfo[MT_JETMETBSTERB] = {spawnstate = S_JETMETBSTERB, radius = 20*FRACUNIT, height = 16*FRACUNIT, flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING}

skincolors[SKINCOLOR_JETMETAL] = {name = "JetMetal", ramp = {3,15,19,23,25,27,29,29,29,30,30,30,30,30,31,31}, accessible = true}

skincolors[SKINCOLOR_SUPERJETMETAL1] = {name = "Super JetMetal 1", ramp = {3,15,19,23,25,27,29,29,29,30,30,30,30,30,31,31}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL2] = {name = "Super JetMetal 2", ramp = {3,15,19,23,236,79,238,238,238,239,239,239,239,239,239,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL3] = {name = "Super JetMetal 3", ramp = {89,65,190,190,77,191,78,78,78,79,79,79,79,238,238,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL4] = {name = "Super JetMetal 4", ramp = {89,85,66,190,190,77,77,191,78,78,78,79,79,79,238,239}, accessible = false}
skincolors[SKINCOLOR_SUPERJETMETAL5] = {name = "Super JetMetal 5", ramp = {89,85,65,66,190,190,190,77,191,191,78,78,79,79,238,239}, accessible = false}

local SKIN = "jetmetalsonic" --Set skin

//Values for Charge Abilities
local MAX_CHARGES = 2		--Maximum amount of charges per jump
local SUPER_MAX_CHARGES = 4	--Maximum amount of charges per jump when super

local FULL_CHARGE_BUILDUP = 17*TICRATE/15			--Amount of charge at maximum, set in global table for HUD script
local HALF_CHARGE_BUILDUP = FULL_CHARGE_BUILDUP/2	--Amount of charge at half-full
local MAX_CHARGE_TIME = 2*TICRATE					--Maximum amount of time allowed to be charging

local BASE_BUILDUP_MOD = 5*FRACUNIT/4	--Buildup modifier at minimum
local ADD_BUILDUP_MOD = 6*FRACUNIT/5	--Buildup modifier at full charge

local BASE_CHRGJMP_HEIGHT = 15*FRACUNIT/2	--Base value for Charge Jump height
local BASE_CHRGTHOK_SPEED = 20*FRACUNIT		--Base value for Charge Thok speed
local WALLBOUNCE_WINDOW = 4*TICRATE/5		--Window of opportunity to perform the wall bounce
local BASE_V_STMPSPEED = -4*FRACUNIT		--Base value for vertical Stomp speed
local BASE_H_STMPSPEED = 6*FRACUNIT			--Base value for horizontal Stomp speed
local BASE_GBOUNCE_HEIGHT = 17*FRACUNIT		--Base value for Ground Bounce height

//Values for Homing Thok
local SEARCH_DIST = 6*RING_DIST/5	--Search distance for valid homing attack targets
local SEARCH_ANGLE = ANGLE_45		--Angle within which to search for valid homing targets

local SPEED_MOD = 2*FRACUNIT/3		--Modifier for movement speed during homing attack
local HOME_TIMER = 3*TICRATE		--Homing attack duration

//Values for Dash Mode
local DASHMODE_ON = 3*TICRATE			--Required build-up to activate Dash Mode
local DASHMODE_CAP = 11*TICRATE/2		--Maximum Dash Mode build-up
local DASHSPD_CAP_MOD = 4*FRACUNIT/3	--Maximum normalspeed multiplier in Dash Mode
local DASHMODE_DECAY = 3*TICRATE/4		--Speed at which Dash Mode decays

local ResetCharge = function(p)
	p.chrgbuildUp = 0
	p.charging = false
	p.chargepercent = 0
	p.buildupmod = 0
	p.effsize = 0
	p.halfchargeeff = false
	p.fullchargeeff = false
end

local function ResetAbilities(p)
	p.chrgjumpUsed = false
	p.superchrgjumpUsed = false
	if p.chrgStomping
		p.prevChrgStomp = true
	end
	p.chrgStomping = false
	p.prepchrgBounce = false
	p.chrgWBounce = 0
	p.chrgGBounce = false
end

local function ConvertCharge(p) --Function to convert charge into a usable variable and set effect size
	p.effsize = 3*FRACUNIT/5
	if p.chrgbuildUp > FULL_CHARGE_BUILDUP
		p.chrgbuildUp = FULL_CHARGE_BUILDUP
		p.effsize = 9*FRACUNIT/10
	elseif p.chrgbuildUp > HALF_CHARGE_BUILDUP
		p.effsize = 4*FRACUNIT/5
	end
	p.buildupmod = BASE_BUILDUP_MOD+FixedMul(ADD_BUILDUP_MOD, FixedDiv(p.chrgbuildUp*FRACUNIT, FULL_CHARGE_BUILDUP*FRACUNIT))
end

local function FloorBreak(mo, sec) --Function to break breakable floors, adapted from MAXControl by Inferno
	for x = mo.x, mo.x + mo.radius, mo.radius
		for y = mo.y, mo.y + mo.radius, mo.radius
			for fof in sec.ffloors()
				if (fof.flags & FF_EXISTS) and (fof.flags & FF_BUSTUP)
				and (mo.z + mo.height == fof.bottomheight or mo.z == fof.topheight
				or (mo.eflags & MFE_VERTICALFLIP) and (mo.z - mo.height == fof.topheight or mo.z == fof.bottomheight))
					EV_CrumbleChain(fof)
				end
			end
		end
	end
end

local function SuperNuke(p, radius)
	if p.powers[pw_super]
		P_StartQuake(20*FRACUNIT, 4)
		P_NukeEnemies(p.mo, p.mo, radius)
		S_StartSound(p.mo, sfx_bkpoof)
	end
end

local function SpawnChargeEffect(p, color)
	local chrgeff = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
	chrgeff.state = S_CHRGEFF1
	chrgeff.color = color
	chrgeff.scale = p.mo.scale/2
	chrgeff.tracer = p.mo
	chrgeff.ischrgeff = true
end

local SpawnLaunchEffect = function(p, abil, size, color)
	local lncheff = P_SpawnMobj(p.mo.x, p.mo.y, (p.mo.z + 36 * p.mo.scale), MT_THOK)
	lncheff.state = S_LAUNCHEFF
	lncheff.color = color
	lncheff.scale = FixedMul(size, p.mo.scale)
	if abil == 1
		lncheff.frame = $|FF_PAPERSPRITE
		lncheff.angle = p.mo.angle + ANGLE_90
	else
		lncheff.frame = $|FF_FLOORSPRITE
	end
end

local function doChargeJump(p)
	local mo = p.mo

	local JUMPHEIGHT = FixedMul(p.buildupmod, BASE_CHRGJMP_HEIGHT) --Calculate Jump Height
	if p.powers[pw_super]
		JUMPHEIGHT = 6*$/5 --Increase jump height by 20% when Super
	end
	if mo.eflags & MFE_UNDERWATER
		JUMPHEIGHT = 3*$/5 --Reduce jump height by 40% when underwater
	end
	P_SetObjectMomZ(mo, JUMPHEIGHT, false)
	P_InstaThrust(mo, mo.angle, FixedMul(p.storeSpd/4, mo.scale))  --Give forward speed equal to 25% stored speed
	mo.state = S_PLAY_CHRGJMP
	p.ghostTrail = 14

	if not p.prepchrgBounce
		p.prepchrgBounce = false
	end
	if p.prepchrgBounce
		p.prepchrgBounce = false
	end

	SuperNuke(p, 475*FRACUNIT)
	p.pflags = $ & ~PF_NOJUMPDAMAGE

	--Lose a charge
	p.charges = $-1
	if p.chrgjumpUsed
		p.superchrgjumpUsed = true
	end
	p.chrgjumpUsed = true
	ResetCharge(p)
end

local function doChargeThok(p)
	local mo = p.mo

	local THOKSPEED = (2*p.storeSpd/3)+FixedMul(p.buildupmod, BASE_CHRGTHOK_SPEED) --Calculate Thok speed
	if THOKSPEED > p.thokspeedcap
		THOKSPEED = p.thokspeedcap
	end
	if p.powers[pw_super]
		THOKSPEED = 6*$/5 --Increase thok speed by 20% when Super
	end
	if mo.eflags & MFE_UNDERWATER
		THOKSPEED = 3*$/5  --Reduce thok speed by 40% when underwater
	end
	P_InstaThrust(mo, mo.angle, FixedMul(THOKSPEED, mo.scale))
	if mo.eflags & MFE_UNDERWATER
		P_SetObjectMomZ(mo, 3*FRACUNIT, false)
	else
		P_SetObjectMomZ(mo, 5*FRACUNIT, false)
	end
	mo.state = S_PLAY_CHRGTHK

	if not p.prepchrgBounce
		p.prepchrgBounce = false
	end
	if p.prepchrgBounce
		p.chrgWBounce = WALLBOUNCE_WINDOW
		p.ghostTrail = WALLBOUNCE_WINDOW
		p.prepchrgBounce = false
	else
		p.ghostTrail = 14
	end

	SuperNuke(p, 475*FRACUNIT)
	p.pflags = $ & ~PF_NOJUMPDAMAGE

	--Lose a charge
	p.charges = $-1
	ResetCharge(p)
end

local function doChargeStomp(p)
	local mo = p.mo

	p.STOMPSPEED = FixedMul(p.buildupmod, BASE_V_STMPSPEED)
	if p.powers[pw_super]
		p.STOMPSPEED = 6*$/5 --Increase stomp speed by 20% when Super
	end
	if mo.eflags & MFE_UNDERWATER
		p.STOMPSPEED = 3*$/5  --Reduce stomp speed by 40% when underwater
	end
	mo.momx = 0
	mo.momy = 0
	if p.effsize > 0
		P_InstaThrust(mo, mo.angle, FixedMul(p.storeSpd/2+BASE_H_STMPSPEED, mo.scale))
	end
	P_SetObjectMomZ(mo, p.STOMPSPEED, true)
	mo.state = S_PLAY_ROLL
	p.ghostTrail = 14

	if not p.prepchrgBounce
		p.prepchrgBounce = false
	end
	if p.prepchrgBounce
		p.chrgGBounce = true
		p.chrgGBouncing = true
		p.prepchrgBounce = false
	end

	SuperNuke(p, 475*FRACUNIT)
	p.pflags = $ & ~PF_NOJUMPDAMAGE

	--Lose a charge
	p.charges = $-1
	p.chrgStomping = true
	ResetCharge(p)
end

local function JetLookForEnemies(p, ringdist, span, above, disregard) --Enemy search. Code re-used and modified from CobaltBW's Fang Popgun Modifications
	local twod = (twodlevel or p.mo.flags2 & MF2_TWOD)
	if (twod)
		ringdist = $/2
		span = 2*$/3
	end

	local maxdist = FixedMul(ringdist, p.mo.scale)
	local closestdist = 0
	local closestmo = nil
	local nonenemiesdisregard = disregard
	searchBlockmap("objects",function(pmo,mo)
		if (mo.flags & MF_NOCLIPTHING) return end
		if (mo.health <= 0) return end

		if not(mo.p)
		and (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)
		and (mo.flags & MF_SHOOTABLE)) or (mo.flags & MF_SPRING)) == !(mo.flags2 & MF2_INVERTAIMABLE))
			return
		end
		if (mo == pmo) return end
		if (mo.flags2 & MF2_FRET) return end
		if (mo.flags & nonenemiesdisregard) return end
		if mo.type == MT_TNTBARREL return end -- Do not target TNT barrels
		if mo.type == MT_METALSONIC_BATTLE return end -- Do not target Metal Sonic (Boss 6)

		//Disallow targeting teammates
		if mo.p and (mo.p.spectator or gametyperules&GTR_FRIENDLY or G_GametypeHasTeams() and mo.p.ctfteam == p.ctfteam)
			return
		end

		//Do angle/distance checks
		local zdist = (pmo.z + pmo.height/2) - (mo.z + mo.height/2)
		local dist = P_AproxDistance(pmo.x - mo.x, pmo.y - mo.y)
		//CBW:	Made the angle checks their own locals, for readability purposes
		//		I also unsigned the angle checks, which appears to correct failed OutOfBounds checks above the player.
		local xyz_angle = abs(R_PointToAngle2(0, 0, dist, zdist))
		local xy_angle = abs(R_PointToAngle2(
				pmo.x + P_ReturnThrustX(pmo, pmo.angle, pmo.radius),
				pmo.y + P_ReturnThrustY(pmo, pmo.angle, pmo.radius),
				mo.x, mo.y) - pmo.angle)

		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist)
			return -- out of range
		end
		if (xyz_angle > span)
			return -- Don't home outside of desired angle!
		end

		if not above -- Don't home above the player if not desired!
			if pmo.eflags & MFE_VERTICALFLIP
			and zdist > 0
				return
			elseif zdist < 0
				return
			end
		end

		if (twod
		and abs(pmo.y-mo.y) > pmo.radius)
			return -- not in your 2d plane
		end

		if ((closestmo and closestmo.valid) and (dist > closestdist))
			return
		end
		if (xy_angle > span)
			return -- behind back
		end

		if not (P_CheckSight(pmo, mo))
			return -- out of sight
		end

		closestmo = mo
		closestdist = dist
	end,p.mo,p.mo.x-maxdist,p.mo.x+maxdist,p.mo.y-maxdist,p.mo.y+maxdist)
	return closestmo
end

local function JetHoming(p, t, spdmod)
	local mo = p.mo
	mo.angle = R_PointToAngle2(mo.x, mo.y, t.x, t.y)

	local dist = P_AproxDistance(P_AproxDistance(t.x - mo.x, t.y - mo.y), t.z - mo.z)
	local speed =  FixedMul(FixedMul(p.actionspd, spdmod), mo.scale)
	if mo.eflags & MFE_UNDERWATER
		speed = 3*$/5 --Reduce speed by 40% when underwater
	end

	mo.momx = FixedMul(FixedDiv(t.x - mo.x, dist), speed)
	mo.momy = FixedMul(FixedDiv(t.y - mo.y, dist), speed)
	mo.momz = FixedMul(FixedDiv(t.z - mo.z, dist), speed)
end

local function JetScreamEffect(mo, color, freq, tics, objecttype)
	if leveltime % freq ~= 0 return end
	local x_adjust = FixedMul(FixedMul(P_RandomRange(-FRACUNIT/2, FRACUNIT/2 - 1), mo.scale), mo.radius)
	local y_adjust = FixedMul(FixedMul(P_RandomRange(-FRACUNIT/2, FRACUNIT/2 - 1), mo.scale), mo.radius)
	local z_adjust = FixedMul(FixedMul(P_RandomFixed(), mo.scale), mo.height)
	if mo.eflags & MFE_VERTICALFLIP
		z_adjust = mo.height - mo.height / 3 - FixedMul(FixedMul(P_RandomFixed(), mo.scale), mo.height)
	end

	local effect = P_SpawnMobj(mo.x + x_adjust, mo.y + y_adjust, mo.z + z_adjust, objecttype)
	if tics ~= nil
		effect.tics = tics
	end
	if color ~= nil
		effect.color = color
		effect.colorized = true
	end
	effect.blendmode = AST_ADD
	if mo.eflags & MFE_VERTICALFLIP
		effect.eflags = $|MFE_VERTICALFLIP
	end

	if not mo.player return end
	if mo.player.powers[pw_super]
		P_InstaThrust(effect, R_PointToAngle2(mo.x, mo.y, effect.x, effect.y), FixedMul(3*FRACUNIT, mo.scale))
		P_SetObjectMomZ(effect, 7*FRACUNIT/2, false)
	end
end

local function SpawnSparkleEffect(p, color)
	local mo = p.mo
	local sparkle = P_SpawnMobj(mo.x + P_RandomRange(-20, 20) * mo.scale, mo.y + P_RandomRange(-20, 20) * mo.scale, mo.z + P_RandomRange(-8, 56) * mo.scale, MT_THOK)
	sparkle.state = S_CHRGSPARKLE
	if sparkle.z > mo.z + 24 * mo.scale
		P_SetObjectMomZ(sparkle, 2*FRACUNIT, false)
	else
		P_SetObjectMomZ(sparkle, -2*FRACUNIT, false)
	end
	P_InstaThrust(sparkle, R_PointToAngle2(mo.x, mo.y, sparkle.x, sparkle.y), FixedMul(2*FRACUNIT, mo.scale))
	sparkle.colorized = true
	sparkle.color = color
	sparkle.scale = mo.scale
end

local function BoosterChase(mo, vert, forwardback, leftright)
	local t = mo.tracer

	local angle = t.player.drawangle

	local foffsetx = P_ReturnThrustX(t, angle, FixedMul(forwardback, mo.scale))
	local foffsety = P_ReturnThrustY(t, angle, FixedMul(forwardback, mo.scale))

	local boffsetx = P_ReturnThrustX(t, angle + ANGLE_90, FixedMul(leftright, mo.scale))
	local boffsety = P_ReturnThrustY(t, angle + ANGLE_90, FixedMul(leftright, mo.scale))

	local offsetz
	if t.eflags & MFE_VERTICALFLIP
		mo.eflags = $|MFE_VERTICALFLIP
		mo.flags2 = $|MF2_OBJECTFLIP
		offsetz = t.height - mo.height - FixedMul(vert, mo.scale)
	else
		mo.eflags = $ & ~MFE_VERTICALFLIP
		mo.flags2 = $ & ~MF2_OBJECTFLIP
		offsetz = FixedMul(vert, mo.scale)
	end

	mo.angle = angle
	P_TeleportMove(mo, t.x + foffsetx + boffsetx, t.y + foffsety + boffsety, t.z + offsetz)
end

local function BoosterJetFume(mo, ghost)
	local x_adjust = P_ReturnThrustX(mo, mo.angle, -17*mo.scale)
	local y_adjust = P_ReturnThrustY(mo, mo.angle, -17*mo.scale)
	if not (mo.eflags & MFE_UNDERWATER)
		local jetfume = P_SpawnMobjFromMobj(mo, x_adjust, y_adjust, 0, MT_THOK)
		jetfume.fuse = 1
		jetfume.sprite = SPR_JETF
		jetfume.colorized = true
		jetfume.color = mo.tracer.player.effcolor
		jetfume.scale = mo.scale/2

		if leveltime % 3 == 0
			jetfume.frame = A|FF_FULLBRIGHT
		elseif leveltime % 3 == 1
			jetfume.frame = B|FF_FULLBRIGHT
		else
			jetfume.frame = C|FF_FULLBRIGHT
		end

		if mo.eflags & MFE_VERTICALFLIP
			jetfume.eflags = $|MFE_VERTICALFLIP
			P_TeleportMove(jetfume, jetfume.x, jetfume.y, jetfume.z + FixedMul(32*FRACUNIT, mo.scale))
		end

		if ghost
			P_SpawnGhostMobj(jetfume)
		end

	else
		local bubble = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SMALLBUBBLE) --Spawn bubbles instead when underwater
		if mo.eflags & MFE_VERTICALFLIP
			P_TeleportMove(bubble, mo.x + x_adjust, mo.y + y_adjust, mo.z + mo.scale)
			bubble.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(bubble, mo.x + x_adjust, mo.y + y_adjust, mo.z - mo.scale)
		end
	end
end

local function DashModeReset(p)
	if p.dashModeactivate
		S_StartSound(p.mo, sfx_kc65) --Vanilla Dash Mode deactivation sound
		p.dashModeactivate = nil
	end
	if not (skins[p.mo.skin].flags & SF_RUNONWATER)
		p.charflags = $ & ~SF_RUNONWATER
	end
	if p.normalspeed ~= skins[p.mo.skin].normalspeed
		p.normalspeed = skins[p.mo.skin].normalspeed
	end
	if p.jumpfactor ~= skins[p.mo.skin].jumpfactor
		p.jumpfactor = skins[p.mo.skin].jumpfactor
	end
end

//Reset stuff when the Player spawns
addHook("PlayerSpawn", function(p)
	if not (p.mo and p.mo.health and p.mo.valid and p.mo.skin == "jetmetalsonic") return end
	ResetAbilities(p)
	ResetCharge(p)
	p.combocount = 0
	if p.deadalready
		p.deadalready = nil
	end
end)

//Recurl by pressing JUMP or SPIN while in Spring state
addHook("SpinSpecial", function(p)
	local mo = p.mo
	if not (mo and mo.valid and mo.health and mo.skin == SKIN) return end
	if mo.state == S_PLAY_SPRING
	and not (p.pflags & PF_SPINDOWN)
		p.pflags = $|PF_JUMPED|PF_SPINDOWN
		mo.state = S_PLAY_ROLL
		mo.eflags = $ & ~MFE_SPRUNG
		S_StartSound(mo, sfx_3db16)
		return true
	end
end)
addHook("JumpSpecial", function(p)
	local mo = p.mo
	if not (mo and mo.valid and mo.skin == SKIN) return end
	if mo.state == S_PLAY_SPRING
	and not (p.pflags & PF_JUMPDOWN)
		p.pflags = $|PF_JUMPED|PF_JUMPDOWN
		mo.state = S_PLAY_ROLL
		mo.eflags = $ & ~MFE_SPRUNG
		S_StartSound(mo, sfx_3db16)
	end
end)

//Hook charging to double jumping
addHook("AbilitySpecial", function(p)
	if not (p.mo and p.mo.health and p.mo.valid and p.mo.skin == SKIN) return end
	if p.powers[pw_carry] return end
	if not p.charging
	and not (p.pflags & (PF_SPINDOWN|PF_JUMPDOWN))
		if p.charges > 0

			--Start Charging
			S_StartSound(p.mo, sfx_cdfm44)
			p.chrgWBounce = 0
			p.chrgGBounce = false
			p.charging = true
			if p.chrgStomping
				p.chrgStomping = false
				p.prevChrgStomp = true
			end
			p.storeSpd = FixedHypot(p.rmomx, p.rmomy)
			p.pflags = ($|PF_NOJUMPDAMAGE) & ~PF_SPINNING
			p.ghostTrail = 0
		else
			
		end
	end
	return true
end)

//Hook Homing Thok to SPIN while jumping
addHook("JumpSpinSpecial", function(p)
	local mo = p.mo
	if not (mo and mo.health and mo.valid and mo.skin == SKIN) return end

	--Go super, checks adapted and modified from Reveries by Katmint
	if All7Emeralds(emeralds) and p.rings > 49 and p.playerstate == PST_LIVE and p.charflags & SF_SUPER
	and not p.powers[pw_super] and not p.powers[pw_carry] and not p.powers[pw_shield]
	and not (p.pflags & (PF_SPINNING|PF_THOKKED|PF_SPINDOWN))
	and not (maptol & TOL_NIGHTS)
	and not p.panim == PA_ABILITY and not p.panim == PA_ABILITY2 and not p.panim == PA_PAIN and not p.panim == PA_ETC
	and not p.mo.state == S_PLAY_CHRG and not p.chrgStomping
	and not p.Homing and not p.charging
	and not P_IsObjectOnGround(p.mo)
		P_DoSuperTransformation(p)
		return true

	--Perform the Homing Thok
	elseif not p.Homing
	and not (p.pflags & (PF_SPINDOWN|PF_THOKKED))
	and mo.tracer and mo.tracer.valid and mo.tracer.health
		S_StartSound(mo, sfx_beflap)
		mo.angle = R_PointToAngle2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
		SpawnLaunchEffect(p, 1, 3*FRACUNIT/5, p.effcolor)
		p.Homing = HOME_TIMER
		p.pflags = $ & ~PF_NOJUMPDAMAGE
		p.chrgStomping = false
		p.ghostTrail = 0
		return true
	end
end)

//Hook Charging behaviour and follow-up buttons in the PreThinkFrame
addHook("PreThinkFrame", do
	for p in players.iterate
		local mo = p.mo
		if not (mo and mo.health and mo.valid and mo.skin == SKIN) return end
		if p.charges == nil
			p.charges = 0
		end

		if p.powers[pw_carry]
			ResetCharge(p)
		end

		--Set visual effect colour
		if p.menu.contents[1][3].value == 0
			p.effcolor = SKINCOLOR_YELLOW
		elseif p.menu.contents[1][3].value == 1
			p.effcolor = SKINCOLOR_ORANGE
		elseif p.menu.contents[1][3].value == 2
			p.effcolor = SKINCOLOR_CRIMSON
		elseif p.menu.contents[1][3].value == 3
			p.effcolor = SKINCOLOR_AETHER
		end

		if p.charging
		and not P_IsObjectOnGround(mo)

			--Lose charging state and all charges when hurt
			if P_PlayerInPain(p)
				ResetCharge(p)
				p.charges = 0
			end

			--Lose charging state when hitting a spring
			if mo.eflags & MFE_SPRUNG
				ResetCharge(p)
			end

			--Set charging animation
			mo.state = S_PLAY_WALK
			mo.sprite2 = SPR2_CHRG
			mo.frame = A

			--Flash colours if not super
			if not p.powers[pw_super]
				if not p.prevcolor
					p.prevcolor = mo.color
				end
				if leveltime % 4 == 0
					mo.color = p.effcolor
				elseif leveltime % 4 == 2
					mo.color = p.prevcolor
				end
			end
			if leveltime % 4 == 0
				mo.colorized = true
			elseif leveltime % 4 == 2
				mo.colorized = false
			end

			--If the JUMP button is held then increase charge
			if (p.cmd.buttons & BT_JUMP)
			and p.chrgbuildUp < MAX_CHARGE_TIME
				p.chrgbuildUp = $+1

				--Charge 50 percent faster when super or when having speed shoes
				if (p.powers[pw_super] or p.powers[pw_sneakers])
				and leveltime % 2 == 0
				and p.chrgbuildUp < MAX_CHARGE_TIME
					p.chrgbuildUp = $+1
				end
				
				--Charge 25% faster while Dash Mode is active
				if p.dashMode >= DASHMODE_ON
				and leveltime % 4 == 0
				and p.chrgbuildUp < MAX_CHARGE_TIME
					p.chrgbuildUp = $+1
				end

				--Reduce momentum and fall slowly while charging
				mo.momx = 8*$/9
				mo.momy = 8*$/9
				mo.momz = 2*$/5

				--Audio and visual cues for charge levels
				if p.chrgbuildUp >= HALF_CHARGE_BUILDUP
				and not p.halfchargeeff
					S_StartSound(mo, sfx_s3ka8)
					p.chrgSparkle = true
					SpawnChargeEffect(p, p.effcolor)
					p.halfchargeeff = true
				elseif p.chrgbuildUp >= FULL_CHARGE_BUILDUP
				and not p.fullchargeeff
					S_StartSound(mo, sfx_s3ka8)
					SpawnChargeEffect(p, p.effcolor)
					p.fullchargeeff = true
					p.prepchrgBounce = true --Bounce possible
				end

				--If the SPIN button is pressed while charging, perform the Charge Jump / Stomp
				if (p.cmd.buttons & BT_SPIN)
				and not (p.pflags & PF_SPINDOWN)
					p.pflags = $|PF_SPINDOWN
					if p.menu.contents[1][5].value == 0
						if (not p.chrgjumpUsed or (p.powers[pw_super] and not p.superchrgjumpUsed))
						and p.chrgbuildUp < MAX_CHARGE_TIME
							S_StartSound(mo, sfx_beflap)
							ConvertCharge(p)
							SpawnLaunchEffect(p, 0, p.effsize, p.effcolor)
							doChargeJump(p)
						end
					else
						S_StartSound(mo, sfx_beflap)
						ConvertCharge(p)
						SpawnLaunchEffect(p, 0, p.effsize, p.effcolor)
						doChargeStomp(p)
					end
				end

			--If the JUMP button is released while charging, perform the Charge Thok or Charge Stomp / Jump
			elseif not (p.cmd.buttons & BT_JUMP)
			and p.chrgbuildUp < MAX_CHARGE_TIME
				S_StartSound(mo, sfx_beflap)
				ConvertCharge(p)
				SpawnLaunchEffect(p, 1, p.effsize, p.effcolor)

				--If holding any direction then perform Charge Thok
				if P_GetPlayerControlDirection(p) ~= 0
					doChargeThok(p)

				--Otherwise, perform Charge Stomp / Jump
				else
					if p.menu.contents[1][5].value == 0
						doChargeStomp(p)
					else
						doChargeJump(p)
					end
				end

			--If charging longer than MAX_CHARGE_TIME cancel charge and lose all charges
			else
				mo.state = S_PLAY_FALL
				ResetCharge(p)
				p.pflags = $|PF_NOJUMPDAMAGE|PF_THOKKED
				p.charges = 0
			end
		else
			S_StopSoundByID(mo, sfx_cdfm44)
			if p.prevcolor
				mo.color = p.prevcolor
				p.prevcolor = nil
			end
			mo.colorized = false
		end
	end
end)

//Jet boosters and aura effect hooked into ThinkFrames
addHook("ThinkFrame", do
	for p in players.iterate
		local mo = p.mo
		if mo and mo.valid and mo.skin == SKIN

			--Spawn boosters if they do not exist yet
			if not p.deadalready
				if not p.jetmetbstrA or not p.jetmetbstrA.valid
					p.jetmetbstrA = P_SpawnMobj(mo.x, mo.y, mo.z, MT_JETMETBSTERA)
					local mo_A = p.jetmetbstrA
					mo_A.tracer = mo
					mo_A.tracecolor = true
					mo_A.skin = mo.skin
					mo_A.sprite = SPR_PLAY
					mo_A.sprite2 = SPR2_JMSB
				end
				if not p.jetmetbstrB or not p.jetmetbstrB.valid
					p.jetmetbstrB = P_SpawnMobj(mo.x, mo.y, mo.z, MT_JETMETBSTERB)
					local mo_B = p.jetmetbstrB
					mo_B.tracer = mo
					mo_B.tracecolor = true
					mo_B.skin = mo.skin
					mo_B.sprite = SPR_PLAY
					mo_B.sprite2 = SPR2_JMSB
				end
			end

			local mo_A = p.jetmetbstrA
			local mo_B = p.jetmetbstrB

			if mo_A and mo_A.valid
			and mo_B and mo_B.valid
				local lastposx_A = mo_A.x
				local lastposy_A = mo_A.y
				local lastposz_A = mo_A.z
				local lastposx_B = mo_B.x
				local lastposy_B = mo_B.y
				local lastposz_B = mo_B.z
				local vertflip = false
				if mo.eflags & MFE_VERTICALFLIP
					vertflip = true
				end
				mo_A.scale = mo.scale
				mo_B.scale = mo.scale
				mo_A.colorized = mo.colorized
				mo_B.colorized = mo.colorized

				--Have the boosters bob up and down
				if leveltime % (2*TICRATE) < TICRATE
					p.relative_z = FixedMul(40*FRACUNIT + (leveltime % TICRATE) / 8*FRACUNIT, mo.scale)
				else
					p.relative_z = FixedMul(40*FRACUNIT + 34*FRACUNIT/8 - (leveltime % TICRATE) / 8*FRACUNIT, mo.scale)
				end

				--Boosters explode when Player is dead
				if mo.state == S_PLAY_DEAD
				or mo.state == S_PLAY_JMSDEAD
					if mo_A.valid and mo_B.valid
						JetScreamEffect(mo_A, nil, 8, nil, MT_BOSSEXPLODE)
						JetScreamEffect(mo_B, nil, 8, nil, MT_BOSSEXPLODE)
						if leveltime % 8 == 0
							S_StartSound(mo, sfx_s3kb4)
						end

						--Player lands on ground instead of clipping through
						if not p.deadalready
							mo.momz = 2*$/3

							mo_A.momx = P_ReturnThrustX(mo_A, mo_A.angle - ANGLE_45 - FixedMul(ANGLE_90, P_RandomFixed()), mo_A.scale)
							mo_A.momy = P_ReturnThrustY(mo_A, mo_A.angle - ANGLE_45 - FixedMul(ANGLE_90, P_RandomFixed()), mo_A.scale)
							mo_A.momz = mo.momz

							mo_B.momx = P_ReturnThrustX(mo_B, mo_B.angle + ANGLE_45 + FixedMul(ANGLE_90, P_RandomFixed()), mo_B.scale)
							mo_B.momy = P_ReturnThrustY(mo_B, mo_B.angle + ANGLE_45 + FixedMul(ANGLE_90, P_RandomFixed()), mo_B.scale)
							mo_B.momz = mo.momz
							p.deadalready = true
						end
						mo.flags = $ & ~MF_NOCLIPHEIGHT
						mo_A.flags = $ & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY)
						mo_B.flags = $ & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY)
					end
					if P_IsObjectOnGround(mo)
						mo.state = S_PLAY_JMSDEAD
					end

					--Delete boosters when dead for 2 seconds
					if p.deadtimer == 2*TICRATE
						P_RemoveMobj(mo_A)
						P_RemoveMobj(mo_B)
					end
				else
					BoosterChase(mo_A, p.relative_z, -10*FRACUNIT, -20*FRACUNIT)
					BoosterChase(mo_B, p.relative_z, -10*FRACUNIT, 20*FRACUNIT)
				end

				--Boosters crackle with electricity when super
				if p.powers[pw_super]
					JetScreamEffect(mo_A, p.effcolor, 3, 4, MT_WATERZAP)
					JetScreamEffect(mo_B, p.effcolor, 3, 4, MT_WATERZAP)
				end
			end

			--Spawn jetfumes under specific circumstances
			if (mo.state == S_PLAY_CHRGJMP or mo.state == S_PLAY_CHRGTHK or p.chrgStomping)
			and p.ghostTrail
				if not p.chrgStomping
					local x_adjust = P_ReturnThrustX(mo, mo.angle, FixedMul(-15*FRACUNIT, mo.scale))
					local y_adjust = P_ReturnThrustY(mo, mo.angle, FixedMul(-15*FRACUNIT, mo.scale))
					local z_adjust = FixedMul(16*FRACUNIT, mo.scale)
					if mo.eflags & MFE_VERTICALFLIP
						z_adjust = FixedMul(-16*FRACUNIT, mo.scale)
					end
					if mo.state == S_PLAY_CHRGJMP
						z_adjust = 0
					end

					if not (mo.eflags & MFE_UNDERWATER)
						local jetfume = P_SpawnMobj(mo.x + x_adjust, mo.y + y_adjust, mo.z + z_adjust, MT_THOK)
						jetfume.fuse = 1
						jetfume.colorized = true
						jetfume.color = p.effcolor
						jetfume.sprite = SPR_JETF
						jetfume.scale = 2*mo.scale/3
						if mo.eflags & MFE_VERTICALFLIP
							jetfume.eflags = $|MFE_VERTICALFLIP
						end

						if leveltime % 3 == 0
							jetfume.frame = A|FF_FULLBRIGHT
						elseif leveltime % 3 == 1
							jetfume.frame = B|FF_FULLBRIGHT
						else
							jetfume.frame = C|FF_FULLBRIGHT
						end
						P_SpawnGhostMobj(jetfume)

					--if underwater, spawn bubbles instead
					else
						P_SpawnMobj(mo.x+x_adjust, mo.y+y_adjust, mo.z+z_adjust, MT_SMALLBUBBLE)
					end
				end
				BoosterJetFume(p.jetmetbstrA, true)
				BoosterJetFume(p.jetmetbstrB, true)
			end
			if mo.state == S_PLAY_RUN
			or mo.state == S_PLAY_DASH
				if p.Homing
					BoosterJetFume(p.jetmetbstrA, true)
					BoosterJetFume(p.jetmetbstrB, true)
					p.followmobj.color = p.effcolor
					P_SpawnGhostMobj(p.followmobj)
				else
					local defnormspd = skins[mo.skin].normalspeed
					if p.dashMode >= DASHMODE_ON
					and ((leveltime % 8 == 0 and p.normalspeed < defnormspd + FixedMul(defnormspd, DASHSPD_CAP_MOD/2))
					or (leveltime % 4 == 0 and p.normalspeed >= defnormspd + FixedMul(defnormspd, DASHSPD_CAP_MOD/2)))
							BoosterJetFume(p.jetmetbstrA, true)
							BoosterJetFume(p.jetmetbstrB, true)
					else
						BoosterJetFume(p.jetmetbstrA, false)
						BoosterJetFume(p.jetmetbstrB, false)
					end
				end
			end

			--Use aura effect under certain circumstances
			if p.Homing
			or p.chrgStomping
			or mo.state == S_PLAY_CHRGJMP
			or mo.state == S_PLAY_CHRGTHK
				local aura = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				aura.fuse = 1
				aura.angle = mo.angle
				aura.sprite = SPR_JMSA
				aura.color = p.effcolor
				aura.dispoffset = 1
				if not (aura.flags2 & MF2_LINKDRAW)
					aura.flags2 = $|MF2_LINKDRAW
				end
				if mo.eflags & MFE_VERTICALFLIP
					aura.eflags = $|MFE_VERTICALFLIP
					P_TeleportMove(aura, aura.x, aura.y, aura.z - FixedMul(12*FRACUNIT, mo.scale))
				end

				if p.Homing
				or mo.state == S_PLAY_CHRGTHK
					aura.frame = A
				elseif p.chrgStomping
					aura.frame = B
				else
					aura.frame = C
				end

				if leveltime % 2 == 1
					aura.frame = $|FF_TRANS50|FF_FULLBRIGHT
				else
					aura.frame = $|FF_TRANS70|FF_FULLBRIGHT
				end
			end
			
			--Sparkle while sparkles are turned on
			if p.chrgSparkle
				if p.chrgbuildUp >= HALF_CHARGE_BUILDUP
				and leveltime % 2 == 0
					SpawnSparkleEffect(p, p.effcolor)

				--Greatly increase sparkle intensity with charge build-up
				elseif p.chrgbuildUp >= FULL_CHARGE_BUILDUP
				and leveltime % 2 == 1
					SpawnSparkleEffect(p, p.effcolor)
					SpawnSparkleEffect(p, p.effcolor)
					SpawnSparkleEffect(p, p.effcolor)
				end
			end

			--Reset sparkles when charging stops
			if not p.charging
			and p.chrgSparkle
				p.chrgSparkle = false
			end
		end
	end
end)

//Set followmobj color in PostThinkFrame
addHook("PostThinkFrame", do
	for p in players.iterate
		if not (p.mo and p.mo.health and p.mo.valid and p.mo.skin == SKIN) return end
		p.followmobj.colorized = true
		p.followmobj.color = p.effcolor
	end
end)

addHook("PlayerThink", function(p)
	local mo = p.mo
	if not (mo and mo.valid and mo.skin == SKIN) return end
	if not mo.health
		if p.chrgStomping
			mo.spritexscale = FRACUNIT
			mo.spriteyscale = FRACUNIT
		end
		p.dashMode = 0
		DashModeReset(p)
		if p.camerascale ~= skins[mo.skin].camerascale
			p.camerascale = skins[mo.skin].camerascale
		end
		return
	end

	JetScreamEffect(mo, p.effcolor, 1, P_RandomRange(4, 8), MT_WATERZAP)
	if p.powers[pw_super]
		JetScreamEffect(mo, p.effcolor, 3, 8, MT_WATERZAP)
	end

	if (maptol & TOL_NIGHTS) return end
	if p.powers[pw_carry]
		if p.chrgStomping
			p.chrgStomping = false
			p.prevChrgStomp = true
		end
		return
	end

	--Do not air walk or air stand
	if p.pflags & ~(PF_JUMPED|PF_SPINNING)
	and not P_PlayerInPain(p)
	and not P_IsObjectOnGround(mo)
	and not p.powers[pw_nocontrol]
	and not p.charging
		if mo.state == S_PLAY_STND
		or mo.state == S_PLAY_WAIT
		or mo.state == S_PLAY_WALK
		or mo.state == S_PLAY_RUN
		or (mo.state == S_PLAY_DASH and not p.Homing)
			mo.state = S_PLAY_SPRING
		end
	end

	--Create trail when required
	if not p.ghostTrail
		p.ghostTrail = 0
	end
	if p.ghostTrail > 0
	or (P_IsObjectOnGround(mo) and p.pflags & PF_SPINNING and not (p.pflags & PF_STARTDASH))
		local playerghost = P_SpawnGhostMobj(mo)
		local boosterghostA = P_SpawnGhostMobj(p.jetmetbstrA)
		local boosterghostB = P_SpawnGhostMobj(p.jetmetbstrB)
		playerghost.colorized = true
		playerghost.color = p.effcolor
		boosterghostA.colorized = true
		boosterghostA.color = p.effcolor
		boosterghostB.colorized = true
		boosterghostB.color = p.effcolor
		if p.ghostTrail > 0
			p.ghostTrail = $-1
		end
	end

	//CHARGE ABILITIES
	p.thokspeedcap = 3*p.normalspeed

	--Return jump damage when entering a rolling state in the air (used for wall bounce)
	if mo.state == S_PLAY_ROLL
	and not P_IsObjectOnGround(mo)
		p.pflags = $ & ~PF_NOJUMPDAMAGE
	end

	--Return to rolling state at the height of a Charge Jump
	if mo.state == S_PLAY_CHRGJMP
		if (mo.momz < 5*FRACUNIT and not (mo.eflags & MFE_VERTICALFLIP))
		or (mo.momz > -5*FRACUNIT and mo.eflags & MFE_VERTICALFLIP)
			mo.state = S_PLAY_ROLL
		end
	end

	--Disable stomp and bounce behaviour when hitting a spring, entering goo or getting hurt
	if (mo.eflags == MFE_SPRUNG or mo.state == S_PLAY_SPRING or mo.eflags & MFE_GOOWATER or P_PlayerInPain(p))
	and (p.chrgStomping or p.chrgWBounce)
		if p.chrgWBounce
			p.chrgWBounce = 0
		end
		if p.chrgGBounce
			p.chrgGBounce = false
			if mo.eflags == MFE_SPRUNG
			or mo.state == S_PLAY_SPRING
				P_SetObjectMomZ(mo, 3*mo.momz/4, true) --Increase Z-momentum by 75% when hitting a spring with a stomp
			end
		end
		if p.chrgStomping
			p.chrgStomping = false
			p.prevChrgStomp = true
		end
	end

	//This next bit is to make comboing and ground bouncing play nice with each other
	if not p.chrgGBouncing
		p.chrgGBouncing = false
	end
	if p.chrgGBouncing
	and not p.chrgGBounce
		p.chrgGBouncing = false
	end

	--Reset everything air-related when on the ground and not bouncing
	if (P_IsObjectOnGround(mo) or (mo.eflags & MFE_JUSTHITFLOOR))
		if p.chrgStomping
			p.chrgStomping = false
			p.prevChrgStomp = true
		end
		if not p.chrgGBounce
			p.chrgGBounce = false
			ResetCharge(p)
			ResetAbilities(p)
			if not p.powers[pw_super]
				p.charges = MAX_CHARGES
			else
				p.charges = SUPER_MAX_CHARGES
			end
			p.ghostTrail = 0
			p.pflags = $ & ~PF_NOJUMPDAMAGE

		--Ground bounce behaviour
		else
			p.chrgGBounce = false
			mo.state = S_PLAY_JUMP
			p.pflags = ($ & ~PF_SPINNING)|PF_JUMPED
			FloorBreak(mo, mo.subsector.sector)

			-- Ground bounce dust from Max Control Pack by Inferno
			for i = 0, 8
				local fa = (i*(ANGLE_180/4))
				local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
				dust.momx = FixedMul(sin(fa),20*FRACUNIT)
				dust.momy = FixedMul(cos(fa),20*FRACUNIT)
			end

			local GBOUNCE_HEIGHT = BASE_GBOUNCE_HEIGHT
			if p.powers[pw_super]
				GBOUNCE_HEIGHT = 6*$/5 --Increase modifier by 20 percent when Super
			end
			if mo.eflags & MFE_UNDERWATER
				GBOUNCE_HEIGHT = 3*$/5 --Decrease modifier by 40 percent when underwater
			end
			P_SetObjectMomZ(mo, GBOUNCE_HEIGHT, false)
			p.ghostTrail = 14
			S_StartSound(mo, sfx_mspogo)
		end
	end
	

	if p.chrgWBounce > 0
		p.chrgWBounce = $-1
	end

	//HOMING THOK
	--Perform sprite scaling and keep Z-momentum constant while stomping
	if p.chrgStomping
		P_SetObjectMomZ(mo, p.STOMPSPEED, true)
		if P_PlayerInPain(p)
		or mo.eflags & MFE_GOOWATER
		or mo.state ~= S_PLAY_ROLL
			p.chrgStomping = false
		end

		if mo.spriteyscale < 3*FRACUNIT/2
			mo.spriteyscale = $+FRACUNIT/10
		end
		if mo.spritexscale > 9*FRACUNIT/10
			mo.spritexscale = $-FRACUNIT/10
		end

	elseif p.prevChrgStomp
		mo.spritexscale = FRACUNIT
		mo.spriteyscale = FRACUNIT
		p.prevChrgStomp = false
	end
	
	if not p.Homing
	and not (p.pflags & PF_THOKKED)
	and not P_IsObjectOnGround(mo)
	and not P_PlayerInPain(p)
		mo.tracer = JetLookForEnemies(p, SEARCH_DIST, SEARCH_ANGLE, true, MF_SPRING|MF_MISSILE|MF_MONITOR) --Search for valid targets
		if mo.tracer and mo.tracer.valid and mo.tracer.health
		and not (mo.state == S_PLAY_SPRING or mo.state == S_PLAY_FALL)
		and not p.charging
			P_SpawnLockOn(p, mo.tracer, S_LOCKON2) --Spawn LockOn object
		end
	end

	--Perform homing attack
	if P_PlayerInPain(p)
	or (mo.eflags & MFE_SPRUNG)
		p.Homing = 0
	end
	if p.Homing
		if not (mo.tracer and mo.tracer.valid and mo.tracer.health)
			p.Homing = 0
		end

		if not p.Homing
			mo.state = S_PLAY_FALL
			p.pflags = $|PF_NOJUMPDAMAGE|PF_THOKKED
		else
			mo.state = S_PLAY_DASH
			p.pflags = ($ & ~PF_NOJUMPDAMAGE)|PF_STASIS
			JetHoming(p, mo.tracer, SPEED_MOD)
			p.Homing = $-1
		end
	end

	//DASH MODE
	local speed = FixedHypot(mo.momx, mo.momy)
	local runspeed = FixedMul(FixedMul(p.runspeed, mo.friction), mo.scale)
	local defnormspd = skins[mo.skin].normalspeed
	local normspd = FixedMul(FixedMul(defnormspd, mo.friction), mo.scale)

	if not p.dashMode
		p.dashMode = 0
	end

	--Build up dashMode when moving at high enough speed or charging a spindash
	if speed >= runspeed
	or p.pflags & PF_STARTDASH
		if p.dashMode < DASHMODE_CAP
			p.dashMode = $+1
			if p.pflags & PF_STARTDASH
			and leveltime % 2 == 0
			and p.dashMode < DASHMODE_CAP
				p.dashMode = $+1
			end
		end

	--Lose dashMode buildup under certain circumstances
	elseif (not P_IsObjectOnGround(mo) and p.dashMode < DASHMODE_ON)
	or (P_IsObjectOnGround(mo) and not p.chrgGBounce) --Synergy with Charge Abilities
		p.dashMode = $-DASHMODE_DECAY
		if p.dashMode < 0
			p.dashMode = 0
		end
	end

	--Fake super peelout based on commented out code from CrossMomentum by Frostiikin
	if mo.state == S_PLAY_SPINDASH
	and p.dashMode >= DASHMODE_ON
		mo.state = S_PLAY_DASHREADY
	end
	if p.statelast
		if (mo.state == S_PLAY_ROLL)
		and (p.statelast == S_PLAY_DASHREADY)
		and P_IsObjectOnGround(mo)
			mo.state = S_PLAY_RUN
			p.pflags = $ & ~PF_SPINNING
		end
	end
	p.statelast = mo.state

	--Do various things once Dash Mode is built up high enough
	if p.dashMode >= DASHMODE_ON
		if not p.dashModeactivate
			S_StartSound(mo, sfx_cdfm40) --Vanilla Dash Mode activation sound
			p.dashModeactivate = true
			p.jumpfactor = 11*$/10 --Increase jump factor by 10%
		end
		if not p.chrgStomping
			p.charflags = $|SF_RUNONWATER --Run on water
		else
			if not (skins[p.mo.skin].flags & SF_RUNONWATER)
				p.charflags = $ & ~SF_RUNONWATER --Disable water running while stomping
			end
		end

		--Spawn pulsing effect
		if (leveltime % 8 == 0 and p.normalspeed < defnormspd + FixedMul(defnormspd, DASHSPD_CAP_MOD/2))
		or (leveltime % 4 == 0 and p.normalspeed >= defnormspd + FixedMul(defnormspd, DASHSPD_CAP_MOD/2))
			p.followmobj.color = p.effcolor
			local dashghost = P_SpawnGhostMobj(mo)
			dashghost.tracecolor = true
			dashghost.tracer = mo
			dashghost.colorized = true
			dashghost.blendmode = AST_ADD
			dashghost.scale = mo.scale
			dashghost.destscale = 4*mo.scale/3
			dashghost.scalespeed = abs(dashghost.scale - dashghost.destscale) / dashghost.fuse
			dashghost.dashactive = true
		end

		if p.normalspeed < FixedMul(defnormspd, DASHSPD_CAP_MOD)
		and P_IsObjectOnGround(mo)
		and speed >= normspd
			p.normalspeed = $ + defnormspd / (3*TICRATE) --Gradually increase normalspeed
			if p.normalspeed > FixedMul(defnormspd, DASHSPD_CAP_MOD)
				p.normalspeed = FixedMul(defnormspd, DASHSPD_CAP_MOD) --Do not overshoot cap
			end
		end

		if speed > defnormspd
			if not p.dashcamera
				p.camerascale = 23*$/20 --Zoom out camera by 15%
				p.dashcamera = true
			end

			if P_IsObjectOnGround(mo)
			and mo.state == S_PLAY_RUN
				mo.state = S_PLAY_DASH
			end
		else

			--Reset things when at lower speed
			if mo.state == S_PLAY_DASH
			and not (p.pflags & PF_STARTDASH)
			and not p.Homing
				mo.state = S_PLAY_RUN
			end
			if p.dashcamera
				p.camerascale = skins[mo.skin].camerascale
				p.dashcamera = false
			end
		end
	else
		DashModeReset(p)
	end

	//COMBO COUNTER
	if P_IsObjectOnGround(p.mo)
	and not p.chrgGBouncing
		p.combocount = 0 --Reset combo counter when on the ground and not bouncing
	end
end)

addHook("PlayerCanDamage", function(p) --Damage enemies while dashing
	if not p.dashMode
		p.dashMode = 0
	end
	if p.dashMode >= DASHMODE_ON return true end
end)

//Behaviour for when an enemy is damaged
addHook("MobjDamage", function(t, i, s)
	if not (i and i.player and i.skin == SKIN) return end
	local p = i.player
	if not P_IsObjectOnGround(i)
	and t.valid
		if p.chrgStomping
			p.chrgStomping = false
			p.prevChrgStomp = true
			i.momz = $/2
		end
		if t.flags & MF_ENEMY|MF_BOSS

			--Recover a single charge if the player has less than one
			if p.charges < 1
				p.charges = 1
			end
			ResetAbilities(p)
			
			p.combocount = $+1 --Increase combo counter when hitting an enemy or boss while airborne
		end
	end
	if t.valid
	and (t.flags & MF_ENEMY|MF_BOSS|MF_MONITOR)
	and p.Homing
		local speed = p.actionspd
		if i.eflags & MFE_UNDERWATER
			speed = 3*$/5 --Reduce speed by 40% when underwater
		end
		P_InstaThrust(i, i.angle, FixedMul(speed/6, i.scale))
		P_SetObjectMomZ(i, speed/10, false)
		p.pflags = $ & ~PF_THOKKED
		i.state = S_PLAY_POSTHOME
		p.Homing = 0
	end
end)

//Line detection code from Krabs's Rebound Dash
addHook("MobjLineCollide", function(mo, line)
	if not (mo and mo.valid and mo.health and mo.skin == SKIN) return end
	local p = mo.player

	local side = P_PointOnLineSide(mo.x, mo.y, line)
	local sector = nil

	if side == 1
		sector = line.frontsector
	else
		sector = line.backsector
	end

	if sector == nil return end

	for rover in sector.ffloors()
		if not (rover.flags & FF_EXISTS) or not (rover.flags & FF_BLOCKPLAYER)
			continue
		end

		local topheight = rover.topheight
		local bottomheight = rover.bottomheight

		if (rover.t_slope)
			topheight = P_GetZAt(rover.t_slope, mo.x, mo.y)
		end
		if (rover.b_slope)
			bottomheight = P_GetZAt(rover.b_slope, mo.x, mo.y)
		end

		if (topheight < mo.z)
			continue
		end

		if (bottomheight > mo.z + mo.height)
			continue
		end

		if (rover.flags & FF_BUSTUP) //and not (rover.flags & FF_STRONGBUST)
			p.bustsector = sector
			p.bustrover = rover
		end
		break
	end
end, MT_PLAYER)

//Behaviour when movement is blocked
addHook("MobjMoveBlocked", function(mo)
	if not (mo and mo.health and mo.valid and mo.skin == SKIN) return end
	local p = mo.player

	--Bounce when hitting a wall with a fully charged Charge Thok
	if p.chrgWBounce
		P_BounceMove(mo)
		mo.momx = 4*$/11
		mo.momy = 4*$/11
		P_SetObjectMomZ(mo, 12*FRACUNIT, false)

		S_StartSound(mo, sfx_mspogo)
		p.chrgWBounce = 0
		p.chrgSparkle = false
		p.ghostTrail = 14
		mo.state = S_PLAY_POSTWBNC
		p.pflags = $|PF_NOJUMPDAMAGE

		--Dust from Krabs's Rebound Dash
		for i = 0, 9
			local dust = P_SpawnMobjFromMobj(mo, 0, 0, mo.scale*18, MT_SPINDUST)
			dust.momx = (mo.momx*2)+(P_RandomRange(-10, 10)*FRACUNIT)
			dust.momy = (mo.momy*2)+(P_RandomRange(-10, 10)*FRACUNIT)
			dust.momz = P_RandomRange(-3, 3)*FRACUNIT
			dust.scale = P_RandomRange(50, 125)*FRACUNIT/100
			dust.destscale = 0
			dust.state = S_BOSSEXPLODE
		end

		--Break bustable FOFs from Krabs's Rebound Dash
		if p.bustsector and p.bustrover
			EV_CrumbleChain(p.bustsector, p.bustrover)
			p.bustsector = nil
			p.bustrover = nil

			--Recover a single charge if the player has less than one
			if p.charges < 1
				p.charges = 1
			end
		end
	end
	
	if p.Homing
		p.Homing = 0
		mo.state = S_PLAY_FALL
		p.pflags = $|PF_NOJUMPDAMAGE|PF_THOKKED
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(mo, mobj)
    if not (mo.valid and mo.skin == SKIN) return end
	local p = mo.player

	--Break spikes and saloon doors with fully charged thoks, modified from spike breaking code by ARJr
	if p.chrgWBounce
		if mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE or mobj.type == MT_SALOONDOOR or mobj.type == MT_SALOONDOORCENTER
			if (mobj.z >= (mo.z - 16*FRACUNIT)) and (mobj.z <= (mo.z + mo.height + 16*FRACUNIT))
			and mobj.type == MT_SPIKE
				P_KillMobj(mobj, mo, mo)
			elseif (mobj.flags2 & MF2_OBJECTFLIP)
			and (mobj.z <= (mo.z - 16*FRACUNIT)) and (mobj.z >= (mo.z + mo.height + 16*FRACUNIT))
			and mobj.type == MT_SPIKE
				P_KillMobj(mobj, mo, mo)

			--Destroy saloon doors
			elseif mobj.type == MT_SALOONDOORCENTER

				--Bounce off of the door
				local bouncex = P_ReturnThrustX(mo, mo.angle + ANGLE_180, 4 * FixedHypot(mo.momx, mo.momy) / 11)
				local bouncey = P_ReturnThrustY(mo, mo.angle + ANGLE_180, 4 * FixedHypot(mo.momx, mo.momy) / 11)
				mo.momx = bouncex
				mo.momy = bouncey
				P_SetObjectMomZ(mo, 12*FRACUNIT, false)
				S_StartSound(mo, sfx_mspogo)

				p.chrgWBounce = 0
				p.chrgSparkle = false
				p.ghostTrail = 14
				mo.state = S_PLAY_POSTWBNC
				p.pflags = $|PF_NOJUMPDAMAGE

				--Dust from Krabs's Rebound Dash
				for i = 0, 9
					local dust = P_SpawnMobjFromMobj(mo, 0, 0, mo.scale*18, MT_SPINDUST)
					dust.momx = (mo.momx*2)+(P_RandomRange(-10, 10)*FRACUNIT)
					dust.momy = (mo.momy*2)+(P_RandomRange(-10, 10)*FRACUNIT)
					dust.momz = P_RandomRange(-3, 3)*FRACUNIT
					dust.scale = P_RandomRange(50, 125)*FRACUNIT/100
					dust.destscale = 0
					dust.state = S_BOSSEXPLODE
				end

				--Debris code is modified from the ground bounce dust from Max Control Pack by Inferno 
				for i = 0, 8
					local fa = (i*(ANGLE_180/4))
					local debris = P_SpawnMobjFromMobj(mobj, 0, 0, mobj.info.height/2, MT_WOODDEBRIS)
					debris.momx = FixedMul(sin(fa), 14*FRACUNIT)
					debris.momy = FixedMul(cos(fa), 14*FRACUNIT)
				end
				S_StartSound(mobj, sfx_wbreak)

				P_KillMobj(mobj, mo, mo) -- Kill door
				
				--Recover a single charge if the player has less than one
				if p.charges < 1
					p.charges = 1
				end
			else
				P_KillMobj(mobj, mo, mo)
			end
		end
    end

	--Break floor and ceiling spikes with fully charged stomps
	if p.chrgGBounce
	and mobj.type == MT_SPIKE
		if (mobj.z >= (mo.z - 16*FRACUNIT)) and (mobj.z <= (mo.z + mo.height + 16*FRACUNIT))
			P_KillMobj(mobj, mo, mo)
		elseif (mobj.flags2 & MF2_OBJECTFLIP)
		and (mobj.z <= (mo.z - 16*FRACUNIT)) and (mobj.z >= (mo.z + mo.height + 16*FRACUNIT))
			P_KillMobj(mobj, mo, mo)
		end
	end

	--Destroy spikes while dashing
	if p.dashMode >= DASHMODE_ON
	and mobj.type == MT_SPIKE
		if mobj.z >= (mo.z-16*FRACUNIT)
		and mobj.z <= (mo.z+mo.height+16*FRACUNIT)
			P_KillMobj(mobj, mo)
		elseif (mobj.flags2 & MF2_OBJECTFLIP)
		and (mobj.z <= mo.z-16*FRACUNIT)
		and (mobj.z >= mo.z+mo.height+16*FRACUNIT)
			P_KillMobj(mobj, mo)
		end
	end
end, MT_PLAYER)

//Hook custom object properties into the generic MobjThinker
addHook("MobjThinker", function(mo)
	if not (mo.tracer and mo.tracer.valid) return end
	local t = mo.tracer

	if mo.tracecolor
		mo.color = t.color
	end

	if mo.ischrgeff
		A_CapeChase(mo, 48<<FRACBITS+1, -40<<FRACBITS)
		if mo.valid
			mo.angle = t.angle + ANGLE_90
		end
	end

	if mo.dashactive
		P_TeleportMove(mo, t.x, t.y, t.z)
	end
end)

hud.add(function(v, p)
	if p.mo and p.mo.skin == "jetmetalsonic"
	and p.powers[pw_carry] ~= CR_NIGHTSMODE

		//Draw the Charge Meter on the HUD, based on Inuyasha's Boss HUD code
		if p.menu.contents[1][1].value --Check to see if the Charge Meter is enabled

			local posx = 17
			local posy = 57

			local CHARGECAP = 99
			local CHARGEFILL = (p.chrgbuildUp*100/FULL_CHARGE_BUILDUP)*CHARGECAP/100

			--Set charge meter fill colour based on menu setting
			local fillcolor = p.mo.color
			if p.prevcolor
				fillcolor = p.prevcolor
			end
			if p.menu.contents[1][2].value == 1
				fillcolor = SKINCOLOR_BLUE
			elseif p.menu.contents[1][2].value == 2
				fillcolor = SKINCOLOR_ORANGE
			elseif p.menu.contents[1][2].value == 3
				fillcolor = SKINCOLOR_RED
			elseif p.menu.contents[1][2].value == 4
				fillcolor = SKINCOLOR_ROSY
			elseif p.menu.contents[1][2].value == 5
				fillcolor = SKINCOLOR_PURPLE
			elseif p.menu.contents[1][2].value == 6
				fillcolor = SKINCOLOR_YELLOW
			elseif p.menu.contents[1][2].value == 7
				fillcolor = SKINCOLOR_GREEN
			end

			--Draw the charge meter
			v.draw(posx, posy, v.cachePatch("CMTRBCKG"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			posy = $+(CHARGECAP-1)
			for i = 1, CHARGECAP
				if CHARGEFILL >= i
					v.draw(posx, posy, v.cachePatch("CMTRFILL"), V_30TRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, v.getColormap(SKIN, fillcolor))
				end
				posy = $-1
			end
			posy = $+1
			v.draw(posx, posy, v.cachePatch("CMTRBASE"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			posx = $+3
			posy = $+CHARGECAP+2
			if p.charges > 3
				v.drawString(posx, posy, "4", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
			elseif p.charges > 2
				v.drawString(posx, posy, "3", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
			elseif p.charges > 1
				v.drawString(posx, posy, "2", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
			elseif p.charges > 0
				v.drawString(posx, posy, "1", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
			else
				v.drawString(posx, posy, "0", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "left")
			end
		end

		//Draw the Combo Counter on the HUD
		if p.menu.contents[1][4].value --Check to see if the Combo Counter is enabled
			if p.combocount > 1
				local posx = 60
				local posy = 148

				--Shift the Combo Counter to the left if the Charge Meter is disabled
				if not p.menu.contents[1][1].value
					posx = $-18
				end

				--Counter cannot display beyond 2 digits
				if p.combocount > 99
					v.drawPaddedNum(posx, posy, 99, 2, V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				else
					v.drawPaddedNum(posx, posy, p.combocount, 2, V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
				end

				posx = $-25
				posy = $+12
				v.drawString(posx, posy, "hits!", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_YELLOWMAP, "left")
			end
		end
	end
end, "game")